SystemOrganization addCategory: #'Parcial-Trenes'!

TestCase subclass: #ParcialTrenesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!ParcialTrenesTest methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:32'!
test01
| unDeposito unaFormacion unaLocomotora unVagonDePasajeros|
'El total de pasajeros que puede transportar una formacin'.
unDeposito:= Deposito new.
unaLocomotora:= Locomotora new initialize:50 y:1000 y:3000.
unVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
unaFormacion:= Formacion new.
unaFormacion agregarLocomotora:unaLocomotora.
unaFormacion agregarVagon:unVagonDePasajeros.
unDeposito agregarFormacion:unaFormacion.
self assert:((unDeposito cantidadPasajeros:unaFormacion)=80).! !

!ParcialTrenesTest methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:32'!
test02
| unDeposito unaLocomotora unVagonDePasajeros unaFormacion otroVagonDePasajeros|
'Cuntos vagones livianos tiene una formacin; un vagn es liviano si su peso mximo es menor a 2500 kg'.
unDeposito:= Deposito new.
unaLocomotora:= Locomotora new initialize:50 y:1000 y:3000.
unVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
otroVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
unaFormacion:= Formacion new.
unaFormacion agregarLocomotora:unaLocomotora.
unaFormacion agregarVagon:unVagonDePasajeros.
unaFormacion agregarVagon:otroVagonDePasajeros.
unDeposito agregarFormacion:unaFormacion.
self assert:((unDeposito cantidadVagonesLivianos:unaFormacion)=0).! !

!ParcialTrenesTest methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:35'!
test03
| unDeposito unaLocomotora unVagonDePasajeros unaFormacion otraLocomotora |
'La velocidad mxima de una formacin, que es el mnimo entre las velocidades mximas de las locomotoras'.
unDeposito:= Deposito new.
unaLocomotora:= Locomotora new initialize:50 y:1000 y:3000.
otraLocomotora:= Locomotora new initialize:30 y:1000 y:3000.
unVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
unaFormacion:= Formacion new.
unaFormacion agregarLocomotora:unaLocomotora.
unaFormacion agregarLocomotora:otraLocomotora.
unaFormacion agregarVagon:unVagonDePasajeros.
unDeposito agregarFormacion:unaFormacion.
self assert:((unDeposito velocidadMaxima:unaFormacion)=30).! !

!ParcialTrenesTest methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:39'!
test04
| unDeposito unaLocomotora otraLocomotora unVagonDePasajeros unaFormacion |
'Si una formacin es eficiente; es eficiente si cada una de sus locomotoras arrastra, al menos, 5 veces su peso (el de la locomotora misma)'.
unDeposito:= Deposito new.
unaLocomotora:= Locomotora new initialize:50 y:1000 y:3000.
otraLocomotora:= Locomotora new initialize:30 y:1000 y:3000.
unVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
unaFormacion:= Formacion new.
unaFormacion agregarLocomotora:unaLocomotora.
unaFormacion agregarLocomotora:otraLocomotora.
unaFormacion agregarVagon:unVagonDePasajeros.
unDeposito agregarFormacion:unaFormacion.
self deny:((unDeposito esEficiente:unaFormacion)).! !

!ParcialTrenesTest methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:44'!
test05
| unDeposito unaLocomotora otraLocomotora unVagonDePasajeros unaFormacion |
'Un depsito necesita un conductor experimentado si alguna de sus formaciones es compleja. Una formacin es compleja si: tiene ms de 20 unidades (sumando locomotoras y vagones), o el peso total (sumando locomotoras y vagones) es de ms de 10000 kg. '.
unDeposito:= Deposito new.
unaLocomotora:= Locomotora new initialize:50 y:1000 y:3000.
otraLocomotora:= Locomotora new initialize:30 y:1000 y:3000.
unVagonDePasajeros:= VagonDePasajeros new initialize:10 y:2.
unaFormacion:= Formacion new.
unaFormacion agregarLocomotora:unaLocomotora.
unaFormacion agregarLocomotora:otraLocomotora.
unaFormacion agregarVagon:unVagonDePasajeros.
unDeposito agregarFormacion:unaFormacion.
self deny:((unDeposito necesitaConductorExperimentado)).! !

Object subclass: #Deposito
	instanceVariableNames: 'locomotoras formaciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 00:56'!
agregarFormacion:unaFormacion
	formaciones add:unaFormacion.! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:15'!
cantidadPasajeros:unaFormacion
	(self existeFormacion:unaFormacion)
		ifTrue:[^unaFormacion cantidadPasajeros]
		ifFalse:['No existeformacin'].! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:16'!
cantidadVagonesLivianos:unaFormacion
	(self existeFormacion:unaFormacion)
		ifTrue:[^unaFormacion cantidadVagonesLivianos]
		ifFalse:['No existeformacin'].! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:40'!
esEficiente:unaFormacion
	(self existeFormacion:unaFormacion)
		ifTrue:[^unaFormacion esEficiente]
		ifFalse:['No existeformacin'].! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:15'!
existeFormacion:unaFormacion
	^formaciones includes:unaFormacion.! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 00:57'!
initialize
	formaciones:= Bag new.
	locomotoras:= Set new.! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:46'!
necesitaConductorExperimentado
	^formaciones anySatisfy:[:each | each esCompleja].! !

!Deposito methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:28'!
velocidadMaxima:unaFormacion
	(self existeFormacion:unaFormacion)
		ifTrue:[^unaFormacion velocidadMaxima]
		ifFalse:['No existeformacin'].! !

Object subclass: #Formacion
	instanceVariableNames: 'locomotoras vagones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:33'!
agregarLocomotora:unaLocomotora
	locomotoras add:unaLocomotora.! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:34'!
agregarVagon:unVagon
	vagones add:unVagon.! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:09'!
cantidadPasajeros
	^vagones inject:0 into:[:sum :each | sum+each cantidadPasajeros].! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:23'!
cantidadVagonesLivianos
	^(vagones select:[:each | each esLiviano]) size.! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:50'!
esCompleja
	^((locomotoras size+vagones size)=20)|
	  (((locomotoras inject:0 into:[:sum :each | sum+each peso])+
	    (vagones inject:0 into:[:sum :each | sum+each peso]))>10000).! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:42'!
esEficiente
	^locomotoras allSatisfy:[:each | each esEficiente ].! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:05'!
initialize
	vagones:= Bag new.
	locomotoras:= Set new.! !

!Formacion methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:38'!
velocidadMaxima
	^((locomotoras collect:[:each | each velocidad]) asSortedCollection: [:each :each2 | each<each2]) first.! !

Object subclass: #Maquinaria
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

Maquinaria subclass: #Locomotora
	instanceVariableNames: 'velMax peso pesoMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!Locomotora methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:43'!
esEficiente
	^(peso*5<=pesoMax).! !

!Locomotora methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:27'!
initialize:unaVelocidad y:unPeso y:unPesoMax
	velMax:= unaVelocidad.
	peso:=unPeso.
	pesoMax:=unPesoMax.! !

!Locomotora methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:50'!
peso
	^peso.! !

!Locomotora methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:31'!
velocidad
	^velMax.! !

Maquinaria subclass: #Vagon
	instanceVariableNames: 'pesoMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!Vagon methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:19'!
esLiviano
	^(pesoMax<2500).! !

!Vagon methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 01:51'!
peso
	^pesoMax.! !

Vagon subclass: #VagonDeCarga
	instanceVariableNames: 'cargaMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!VagonDeCarga methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 00:50'!
initialize:unaCargaMax
	cargaMax:=unaCargaMax.
	pesoMax:= cargaMax+160.! !

Vagon subclass: #VagonDePasajeros
	instanceVariableNames: 'largo ancho cantidadPasajerosMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial-Trenes'!

!VagonDePasajeros methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 00:45'!
cantidadPasajeros
	^cantidadPasajerosMax.! !

!VagonDePasajeros methodsFor: 'as yet unclassified' stamp: 'Guidito 11/27/2012 00:49'!
initialize:unLargo y:unAncho
	largo:=unLargo.
	ancho:=unAncho.
	(ancho<2.5) 
	ifTrue:[cantidadPasajerosMax:= largo*8]
	ifFalse:[cantidadPasajerosMax:= largo*10].
	pesoMax:= cantidadPasajerosMax*80.! !
